"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var set_1 = require("./set");
var isObject = function (obj) {
    return typeof obj === 'object' && obj !== null && !Array.isArray(obj);
};
function mergeDeep(input, changes) {
    var result = input;
    for (var key in changes) {
        var childChange = changes[key];
        var newChild = isObject(childChange)
            ? mergeDeep(input[key] || {}, childChange)
            : childChange;
        result = set_1.set(result, key, newChild);
    }
    return result;
}
exports.mergeDeep = mergeDeep;
;
//# sourceMappingURL=merge-deep.js.map